#download Qt5 mingw64 environment from :
#http://www.rpmfind.net//linux/RPM/fedora/21/x86_64/m/mingw64-qt5-qtbase-5.3.2-1.fc21.noarch.html
#mingw64-qt5-qtbase-5.3.2-1.fc21.noarch.rpm
#mingw64-qwt-5.2.3
#mingw64-qwt-qt

# cd buildwin64
# cmake -DCMAKE_BUILD_TYPE=Release -DCMAKE_TOOLCHAIN_FILE=../win64/Toolchain-mingw64.cmake ..
# export LD_LIBRARY_PATH=/opt/win32/usr/x86_64-w64-mingw32/lib

SET (QT_DEFINITIONS "QT_DLL")

SET (USEQT4 1)
SET (USEQT5 1)

#SET (MINGW 1)

# this one is important
SET(CMAKE_SYSTEM_NAME Windows)
#this one not so much
SET(CMAKE_SYSTEM_VERSION 1)

SET (WINDAUBE_ENV_PATH /opt/win32)
# it worked on 27 nov 2013 :
# download and install from http://download.qt-project.org/archive/qt/4.8/4.8.2/ the mingw32 version

#SET(QMAKE_PREFIX    /usr/bin/qmake-qt4 -spec win32-crossCompil-g++ CONFIG=release)
#SET(QT_PREFIX    /usr/local/src/mingw32_f15/qt-4.7.1/i686-pc-mingw32/sys-root/mingw)
#SET(QT_PREFIX    /usr/local/src/mingw_qt/usr/i686-pc-mingw32/sys-root/mingw)
SET(QT_PREFIX    ${WINDAUBE_ENV_PATH}/qt-4.8.7)
SET(QT5_PREFIX    ${WINDAUBE_ENV_PATH}/qt-5.6.0)


SET (Qt5Core_DIR "${QT5_PREFIX}/include/qt5/QtCore")
SET (Qt5Concurrent_DIR "${QT5_PREFIX}/include/qt5/QtConcurrent")
SET (Qt5Gui_DIR "${QT5_PREFIX}/include/qt5/QtGui")

IF (USEQT5)
#SET (CMAKE_MODULE_PATH "/home/langella/opt/qt-5.6.0/lib/cmake")
set(CMAKE_INSTALL_RPATH "${WINDAUBE_ENV_PATH}/usr/x86_64-w64-mingw32/lib")
set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
#message( "CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH}")
  SET (CMAKE_FIND_LIBRARY_PREFIXES "${QT5_PREFIX}/lib")
  SET (CMAKE_FIND_LIBRARY_SUFFIXES ".dll")
#  FIND_PACKAGE( Qt5Core REQUIRED )
#  FIND_PACKAGE( Qt5Concurrent REQUIRED )
#  FIND_PACKAGE( Qt5Gui REQUIRED )
  
   set(Qt5Core_LIBRARY_DIRS "${QT5_PREFIX}/lib") 
  SET(Qt5Core_LIBRARY "Qt5Core.dll")
  SET(Qt5Core_LIBRARIES ${Qt5Core_LIBRARY})
  
  
  set(Qt5Core_HEADERS_DIR ${QT5_PREFIX}/include)
  set(Qt5Core_LIBRARY_DIRS ${QT5_PREFIX}/lib)

  set(Qt5Core_LIBRARY ${QT5_PREFIX}/lib/libQt5Core.dll.a)
  set(Qt5Core_LIBRARY_RELEASE ${QT5_PREFIX}/lib/libQt5Core.dll.a)
  set(Qt5Core_INCLUDE_DIR ${QT5_PREFIX}/include/QtCore)

  
ENDIF(USEQT5)
 
#SET(QT_MOC_EXECUTABLE      /usr/local/src/QtSDK/Desktop/Qt/4.8.1/gcc/bin/moc)
#SET(QMAKE_UIC      /usr/local/src/QtSDK/Desktop/Qt/4.8.1/gcc/bin/uic)
#SET(QMAKE_RCC      /usr/local/src/QtSDK/Desktop/Qt/4.8.1/gcc/bin/rcc)

# specify the cross compiler
#cc++
SET(CMAKE_C_COMPILER   /usr/bin/x86_64-w64-mingw32-gcc)
SET(CMAKE_CXX_COMPILER /usr/bin/x86_64-w64-mingw32-g++)
SET(CMAKE_RC_COMPILER /usr/bin/x86_64-w64-mingw32-windres)

# where is the target environment
#http://qt.nokia.com/downloads/windows-cpp
SET(CMAKE_FIND_ROOT_PATH  /usr/i586-mingw32msvc ${QT_PREFIX} ${QT5_PREFIX})

# search for programs in the build host directories
SET(CMAKE_FIND_ROOT_PATH_MODE_PROGRAM NEVER)
# for libraries and headers in the target directories
SET(CMAKE_FIND_ROOT_PATH_MODE_LIBRARY ONLY)
SET(CMAKE_FIND_ROOT_PATH_MODE_INCLUDE ONLY)


set (CMAKE_CXX_FLAGS " -fexceptions -mthreads -fmessage-length=0 -fident ")

set(ADD_MINGW_EXE_LINKER_FLAGS
  " -static-libgcc -static-libstdc++ "
  )
#--enable-auto-import
#set(CMAKE_EXE_LINKER_FLAGS
#"${CMAKE_EXE_LINKER_FLAGS} -Wl,--enable-auto-import"
#)
# remove console
#set(CMAKE_EXE_LINKER_FLAGS
#"${CMAKE_EXE_LINKER_FLAGS} -Wl,--subsystem,windows"
#)

#set(
#CMAKE_SHARED_LIBRARY_CXX_FLAGS
#"${CMAKE_SHARED_LIBRARY_CXX_FLAGS} -Wl,--enable-auto-import "
#)
set(
CMAKE_SHARED_LIBRARY_CXX_FLAGS
"${CMAKE_SHARED_LIBRARY_CXX_FLAGS} -shared -Wl,--subsystem,windows -DDLL"
)

set(QT_HEADERS_DIR ${QT_PREFIX}/include)
set(QT_LIBRARY_DIR ${QT_PREFIX}/lib)

set(QT_QTCORE_LIBRARY ${QT_PREFIX}/lib/libQtCore4.dll.a)
set(QT_QTCORE_LIBRARY_RELEASE ${QT_PREFIX}/lib/libQtCore4.dll.a)
set(QT_QTCORE_INCLUDE_DIR ${QT_PREFIX}/include/QtCore)

set(QT_QTXML_LIBRARY ${QT_PREFIX}/lib/libQtXml4.dll.a)
set(QT_QTXML_LIBRARY_RELEASE ${QT_PREFIX}/lib/libQtXml4.dll.a)
set(QT_QTXML_INCLUDE_DIR ${QT_PREFIX}/include/QtXml)

set(QT_QTGUI_LIBRARY ${QT_PREFIX}/lib/libQtGui4.dll.a)
set(QT_QTGUI_LIBRARY_RELEASE ${QT_PREFIX}/lib/libQtGui4.dll.a)
set(QT_QTGUI_INCLUDE_DIR ${QT_PREFIX}/include/QtGui)

set(QT_QTXMLPATTERNS_LIBRARY ${QT_PREFIX}/lib/libQtXmlPatterns4.dll.a)
set(QT_QTXMLPATTERNS_RELEASE ${QT_PREFIX}/lib/libQtXmlPatterns4.dll.a)
set(QT_QTXMLPATTERNS_INCLUDE_DIR ${QT_PREFIX}/include/QtXmlPatterns)




SET (Qt5Core_DIR "${QT5_PREFIX}/include")

#set(QT_BINARY_DIR   ${QT_PREFIX}/bin)
#set(QT_LIBRARY_DIR  ${QT_PREFIX}/lib)
#set(QT_QTCORE_LIBRARY   ${QT_PREFIX}/lib/libQtCore4.dll.a)
#set(QT_QTCORE_INCLUDE_DIR ${QT_PREFIX}/include/QtCore)
#set(QT_MOC_EXECUTABLE  ${QT_PREFIX}/moc)
#set(QT_QMAKE_EXECUTABLE  ${QT_PREFIX}/qmake)
#set(QT_UIC_EXECUTABLE  ${QT_PREFIX}/uic)
